image: "registry.fedoraproject.org/fedora:40"
variables:
    GIT_SUBMODULE_STRATEGY: recursive
    GIT_SUBMODULE_UPDATE_FLAGS: --checkout

before_script:
  - dnf update -y --nogpgcheck
  - dnf install -y --nogpgcheck git gcc meson appstream-devel glib2-devel gobject-introspection-devel
  - git submodule update --init
  - curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- --default-toolchain none -y
  - source $HOME/.cargo/env
  - rustup toolchain install nightly --profile minimal --allow-downgrade -c rustfmt
  - curl --proto '=https' --tlsv1.2 -sSf -o gir-rustdoc.py
    https://gitlab.gnome.org/World/Rust/gir-rustdoc/-/raw/main/gir-rustdoc.py
  - chmod +x gir-rustdoc.py

build:
  script:
    - cargo build --all-features
    - cargo test

docs:
  stage: test
  variables:
    RUSTDOCFLAGS: "--cfg docsrs"
    RUSTFLAGS: --cfg docsrs
  script:
    # generate the docs
    - cargo install rustdoc-stripper
    - ./generator.py --embed-docs
    - rustup default nightly
    - eval $(./gir-rustdoc.py pre-docs)
    - cargo doc --no-deps --all-features
    - mv target/doc/ docs
  artifacts:
    paths:
      - docs

pages:
  stage: deploy
  script:
    - ./gir-rustdoc.py html-index
    # main docs
    - mkdir public/git
    - mv docs public/git/docs
    # stable docs
    - ./gir-rustdoc.py docs-from-artifacts
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_DEFAULT_BRANCH == $CI_COMMIT_BRANCH
